/* 
 * Rotary encoder test program
 * File:   main.c
 * Author: saka
 *
 * Created on 2017/01/16, 23:03
 */
//#define _XTAL_FREQ  (10000000)
#include <stdio.h>
#include <stdlib.h>
#include "lcd4.h"
#include <xc.h>
// CONFIG
#pragma config FOSC = HS        // Oscillator Selection bits (HS oscillator)
#pragma config WDTE = OFF       // Watchdog Timer (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable bit (Power-up Timer is enabled)
#pragma config CP = OFF         // Code Protection bit (Code protection disabled)
#define SELECTSW PORTBbits.RB4
#define RE_A PORTBbits.RB5
#define RE_B PORTBbits.RB6

short int di;
unsigned short val[2];

void putch(unsigned char c) {         // define putch() for standard i/o functions
    Putc_LCD4(c);
}


short read_re(void){
   static char index=0;
   const char re_tbl[] = {0,1,-1,0,-1,0,0,1,1,0,0,-1,0,-1,1,0};
   __delay_ms(3);
   index = (0x3&index)<<2 + RE_B<<1 + RE_A;
   /*
   static char re_tbl[] = {1,1,-1,-1,-1,-1,1,1};
   index = (0x1&index)<<2 + RE_B<<1 + RE_A;
   */
   return(re_tbl[index]);
}

void __interrupt ISR(void){
    if(SELECTSW==0){
        di++;
        if(di>2)
            di==0;
    }
    else {
        val[di] += read_re();
    }
    RBIF = 0;
}

void main(void) {
    
    TRISA=0x00;                  // RA is assigned to LCD data, RB0=E, RB1=RS
    PORTA=0x00;
    TRISB=0xf0;                  // RB[4:7] is assigned for sw and rotary encoder
    PORTB=0x00;
    INTCON=0x88;
    
    Init_LCD4();

    // main loop
    while(1){
        Set_DDA(0x0a);
        printf("%d", PORTB>>5);
        Set_DDA(0x00);
        if(di == 0){
            printf("*%4u", val[0]);
        }else{
            putchar(' ');
        }
        Set_DDA(0x40);
        if(di == 0){
            putchar(' ');
        }else{
            printf("*%4u", val[1]);
        }
        SLEEP;
    }
}

